'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _translate = require('./utils/translate');

var _translate2 = _interopRequireDefault(_translate);

var _margin = require('./constants/margin');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Chart = function Chart(_ref) {
  var children = _ref.children,
      className = _ref.className,
      height = _ref.height,
      transform = _ref.transform,
      width = _ref.width;
  return _react2.default.createElement(
    'svg',
    {
      className: className,
      height: height,
      width: width },
    _react2.default.createElement(
      'g',
      {
        className: 'chart',
        transform: transform },
      children
    )
  );
};

Chart.propTypes = {
  height: _propTypes2.default.number.isRequired,
  transform: _propTypes2.default.string,
  width: _propTypes2.default.number.isRequired
};

Chart.defaultProps = {
  transform: (0, _translate2.default)(_margin.MARGIN.left, _margin.MARGIN.top)
};

exports.default = Chart;