'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _d = require('d3');

var d3 = _interopRequireWildcard(_d);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MouseTracker = function (_React$Component) {
  _inherits(MouseTracker, _React$Component);

  function MouseTracker() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MouseTracker);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MouseTracker.__proto__ || Object.getPrototypeOf(MouseTracker)).call.apply(_ref, [this].concat(args))), _this), _this._handleMouseMove = function (e) {
      // Force the event to persist so D3 can use it.
      e.persist();

      // Hack: Temporarily set the event for the mouse.
      var mouse = void 0;
      d3.customEvent(e, function () {
        mouse = d3.mouse((0, _reactDom.findDOMNode)(_this));
      });

      var _this$props = _this.props,
          onMouseMove = _this$props.onMouseMove,
          xScale = _this$props.xScale,
          yScale = _this$props.yScale;

      // Normalize for different scales by converting the mouse position to an
      // x-coordinate in the data.

      onMouseMove(mouse, xScale, yScale);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MouseTracker, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          onMouseOut = _props.onMouseOut,
          xScale = _props.xScale,
          yScale = _props.yScale;


      return _react2.default.createElement(
        'g',
        {
          onMouseMove: this._handleMouseMove,
          onMouseOut: onMouseOut },
        _react2.default.createElement('rect', {
          height: yScale.range()[0],
          style: {
            fill: 'none',
            pointerEvents: 'all'
          },
          width: xScale.range()[1]
        })
      );
    }
  }]);

  return MouseTracker;
}(_react2.default.Component);

MouseTracker.propTypes = {
  onMouseMove: _propTypes2.default.func.isRequired,
  onMouseOut: _propTypes2.default.func.isRequired,
  xScale: _propTypes2.default.func.isRequired,
  yScale: _propTypes2.default.func.isRequired
};

exports.default = MouseTracker;